{ KOL MCK } // Do not remove this line!
{$DEFINE KOL_MCK}
unit Unit1;

interface

{$IFDEF KOL_MCK}
uses Windows, Messages, KOL {$IF Defined(KOL_MCK)}{$ELSE}, mirror, Classes, Controls, mckCtrls, mckObjs, Graphics {$IFEND (place your units here->)};
{$ELSE}
{$I uses.inc}
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, mirror;
{$ENDIF}

type
  {$IF Defined(KOL_MCK)}
  {$I MCKfakeClasses.inc}
  {$IFDEF KOLCLASSES} {$I TForm1class.inc} {$ELSE OBJECTS} PForm1 = ^TForm1; {$ENDIF CLASSES/OBJECTS}
  {$IFDEF KOLCLASSES}{$I TForm1.inc}{$ELSE} TForm1 = object(TObj) {$ENDIF}
    Form: PControl;
  {$ELSE not_KOL_MCK}
  TForm1 = class(TForm)
  {$IFEND KOL_MCK}
    KOLProject1: TKOLProject;
    KOLForm1: TKOLForm;
    PaintBox1: TKOLPaintBox;
    Panel1: TKOLPanel;
    EditBox1: TKOLEditBox;
    Button1: TKOLButton;
    Button2: TKOLButton;
    Use_Scroll: TKOLCheckBox;
    Thread1: TKOLThread;
    Label1: TKOLLabel;
    Half_pixel: TKOLCheckBox;
    procedure PaintBox1Paint(Sender: PControl; DC: HDC);
    procedure KOLForm1Destroy(Sender: PObj);
    procedure EditBox1Change(Sender: PObj);
    procedure Button1Click(Sender: PObj);
    procedure Button2Click(Sender: PObj);
    function PaintBox1Message(var Msg: tagMSG; var Rslt: Integer): Boolean;
    procedure KOLForm1FormCreate(Sender: PObj);
    procedure Use_ScrollClick(Sender: PObj);
    function Thread1Execute(Sender: PThread): Integer;
    procedure PaintBox1Resize(Sender: PObj);
    procedure Half_pixelClick(Sender: PObj);
  private
    { Private declarations }
  public
    { Public declarations }
    OffsetX: Integer;
    LastTik: DWORD;
    Bmp, Bmp2: PBitmap;
  end;

var
  Form1 {$IFDEF KOL_MCK} : PForm1 {$ELSE} : TForm1 {$ENDIF} ;

{$IFDEF KOL_MCK}
procedure NewForm1( var Result: PForm1; AParent: PControl );
{$ENDIF}

implementation

var TextToScroll: String = 'Sample smooth scrolling text';
    Period: DWORD = 16; // better values = N * (1000 / VSync_in_Hertz)
    useScroll: Boolean = TRUE;
    halfPixel: Boolean = TRUE;
    step: Integer;

{$IF Defined(KOL_MCK)}{$ELSE}{$R *.DFM}{$IFEND}

{$IFDEF KOL_MCK}
{$I Unit1_1.inc}
{$ENDIF}

procedure TForm1.PaintBox1Paint(Sender: PControl; DC: HDC);
var R: TRect;
    Big, B: PBitmap;
    h: Integer;
begin
    if  (Bmp <> nil)
    and (Bmp.Width <> PaintBox1.Width)
    and (Bmp.Height <> PaintBox1.Height) then
        Free_And_Nil( Bmp );
    if  Bmp = nil then
    begin
        Bmp := NewBitmap( PaintBox1.Width, PaintBox1.Height );
        Bmp.Canvas.Brush.Color := clWindow;
        Bmp.Canvas.Font.Assign( PaintBox1.Font );
        Bmp.Canvas.Font.FontQuality := fqAntialiased;
        h := Bmp.Canvas.TextHeight(TextToScroll);
        Bmp.Canvas.TextRect( Bmp.BoundsRect, 0, (Bmp.Height - h) div 2,
            TextToScroll );
        //Bmp.SaveToFile( GetStartDir + 'bmp.bmp' );

        Big := NewDibBitmap( Bmp.Width*2, Bmp.Height, pf32bit );
        Big.Canvas.Brush.Color := clWindow;
        Big.Canvas.FillRect( Big.BoundsRect );
        SetStretchBltMode( Big.Canvas.Handle, halftone );
        Bmp.StretchDraw( Big.Canvas.Handle, MakeRect( 1, 0, Big.Width+1, Big.Height ) );

        Bmp2 := NewDibBitmap( Bmp.Width, Bmp.Height, pf32bit );
        SetStretchBltMode( Bmp2.Canvas.Handle, halftone );
        Big.StretchDraw( Bmp2.Canvas.Handle, Bmp2.BoundsRect );
        //Bmp2.SaveToFile( GetStartDir + 'bmp2.bmp' );
        Big.Free;
    end;

    if  step and 1 = 1 then
        B := Bmp
    else
        B := Bmp2;
    R := PaintBox1.ClientRect;
    OffsetRect( R, -OffsetX, 0 );
    B.Draw( Sender.Canvas.Handle, R.Left, R.Top );
    OffsetRect( R, PaintBox1.Width, 0 );
    B.Draw( Sender.Canvas.Handle, R.Left, R.Top );

    if  Thread1.Suspended then
        Thread1.Resume;
end;

procedure TForm1.KOLForm1Destroy(Sender: PObj);
begin
    Free_And_Nil( Bmp );
    Free_And_Nil( Bmp2 );
end;

procedure TForm1.EditBox1Change(Sender: PObj);
var n: Integer;
begin
    n := Str2Int( EditBox1.Text );
    if  n > 0 then
        Period := n;
end;

procedure TForm1.Button1Click(Sender: PObj);
var n: Integer;
begin
    n := Str2Int( EditBox1.Text ) - 1;
    if  n > 0 then
        EditBox1.Text := Int2Str( n );
end;

procedure TForm1.Button2Click(Sender: PObj);
var n: Integer;
begin
    n := Str2Int( EditBox1.Text ) + 1;
    if  n > 0 then
        EditBox1.Text := Int2Str( n );
end;

function TForm1.PaintBox1Message(var Msg: tagMSG;
  var Rslt: Integer): Boolean;
begin
    Result := FALSE;
    if  Msg.message = WM_ERASEBKGND then
    begin
        Result := TRUE;
        Rslt := 1;
    end;
end;

procedure TForm1.KOLForm1FormCreate(Sender: PObj);
begin
    //SetThreadPriority( GetCurrentThread, THREAD_PRIORITY_ABOVE_NORMAL );
end;

procedure TForm1.Use_ScrollClick(Sender: PObj);
begin
    useScroll := Use_Scroll.Checked;
end;

function TForm1.Thread1Execute(Sender: PThread): Integer;
begin
    step := 0;
    while not AppletTerminated do
    begin
        inc( step );
        if  (step and 1 = 0) or not halfPixel then
        begin
            inc( OffsetX );
            if  OffsetX >= PaintBox1.Width then
                OffsetX := 0;
        end;
        if  useScroll
        and (not halfPixel
            or halfPixel and (step and 1 = 0)) then
        begin
            ScrollWindow( PaintBox1.Handle, -1, 0, nil, nil );
        end
          else
        begin
            PaintBox1.Invalidate;
        end;
        PaintBox1.Update;
        Sleep( Period );

    end;
    Result := 0;
end;

procedure TForm1.PaintBox1Resize(Sender: PObj);
begin
    PaintBox1.Invalidate;
    PaintBox1.Update;
end;

procedure TForm1.Half_pixelClick(Sender: PObj);
begin
    halfPixel := Half_pixel.Checked;
end;

end.


